Attribute VB_Name = "POSDLLFuncs"
Dim state_print As Long

Public Declare Function EnumPrinters Lib "winspool.drv" Alias "EnumPrintersA" (ByVal flags As Long, ByVal name As String, ByVal Level As Long, pPrinterEnum As Byte, ByVal cdBuf As Long, pcbNeeded As Long, pcReturned As Long) As Long

Public downstand56 As Boolean
Public downstand80 As Boolean
Public hasdowntoFlash56 As Boolean
Public hasdowntoFlash80 As Boolean
Public save As Long
Public state6 As Long
Public a As Long
Public return1 As Long

Public Type DEVMODE
        dmDeviceName As String * 32
        dmSpecVersion As Integer
        dmDriverVersion As Integer
        dmSize As Integer
        dmDriverExtra As Integer
        dmFields As Long
        dmOrientation As Integer
        dmPaperSize As Integer
        dmPaperLength As Integer
        dmPaperWidth As Integer
        dmScale As Integer
        dmCopies As Integer
        dmDefaultSource As Integer
        dmPrintQuality As Integer
        dmColor As Integer
        dmDuplex As Integer
        dmYResolution As Integer
        dmTTOption As Integer
        dmCollate As Integer
        dmFormName As String * 32
        dmUnusedPadding As Integer
        dmBitsPerPel As Long
        dmPelsWidth As Long
        dmPelsHeight As Long
        dmDisplayFlags As Long
        dmDisplayFrequency As Long
End Type

Public Type ACL
        AclRevision As Byte
        Sbz1 As Byte
        AclSize As Integer
        AceCount As Integer
        Sbz2 As Integer
End Type

Public Type SECURITY_DESCRIPTOR
        Revision As Byte
        Sbz1 As Byte
        Control As Long
        Owner As Long
        Group As Long
        Sacl As ACL
        Dacl As ACL
End Type


Public Type PRINTER_INFO_2
        pServerName As String
        pPrinterName As String
        pShareName As String
        pPortName As String
        pDriverName As String
        pComment As String
        pLocation As String
        pDevMode As DEVMODE
        pSepFile As String
        pPrintProcessor As String
        pDatatype As String
        pParameters As String
        pSecurityDescriptor As SECURITY_DESCRIPTOR
        Attributes As Long
        Priority As Long
        DefaultPriority As Long
        StartTime As Long
        UntilTime As Long
        Status As Long
        cJobs As Long
        AveragePPM As Long
End Type



Public Declare Function GetLastError Lib "kernel32" () As Long

Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

'System control

Public Declare Function Impact_Open Lib "ImpactDLL.dll" (ByVal pszPortName As String, ByVal nComBaudrate As Long, ByVal nComDataBits As Long, ByVal nComStopBits As Long, ByVal nComParity As Long, ByVal nComFlowControl As Long) As Long

Public Declare Function Impact_Close Lib "ImpactDLL.dll" (ByVal hPort As Long, ByVal nPortType As Integer) As Long

Public Declare Function Impact_Reset Lib "ImpactDLL.dll" (ByVal hPort As Long, ByVal nPortType As Integer) As Long

Public Declare Function Impact_BeginSaveFile Lib "ImpactDLL.dll" (ByVal hPort As Long, ByVal lpFileName As String, ByVal bToPrinter As Boolean) As Long

Public Declare Function Impact_EndSaveFile Lib "ImpactDLL.dll" (ByVal hPort As Long) As Long

Public Declare Function Impact_SetCharSetAndCodePage Lib "ImpactDLL.dll" (ByVal hPort As Long, ByVal nCharSet As Long, ByVal nCodePage As Long) As Long
    
Public Declare Function Impact_FeedLine Lib "ImpactDLL.dll" (ByVal hPort As Long, ByVal nPortType As Integer) As Long

Public Declare Function Impact_SetLineSpacing Lib "ImpactDLL.dll" (ByVal hPort As Long, ByVal nPortType As Integer, ByVal nDistance As Long) As Long

Public Declare Function Impact_SetRightSpacing Lib "ImpactDLL.dll" (ByVal hPort As Long, ByVal nPortType As Integer, ByVal nDistance As Long) As Long

Public Declare Function Impact_CutPaper Lib "ImpactDLL.dll" (ByVal hPort As Long, ByVal nPortType As Integer, ByVal nMode As Long, ByVal nDistance As Long) As Long

Public Declare Function Impact_PreDownloadBmpToRAM Lib "ImpactDLL.dll" (ByVal hPort As Long, ByVal nPortType As Integer, ByVal pszPath As String, ByVal nID As Long) As Long

Public Declare Function Impact_PreDownloadBmpsToFlash Lib "ImpactDLL.dll" (ByVal hPort As Long, ByVal nPortType As Integer, pszPaths As String, ByVal nCount As Long, ErrID As Integer) As Long


Public Declare Function Impact_QueryStatus Lib "ImpactDLL.dll" (ByVal hPort As Long, ByVal nPortType As Integer, ByVal pszStatus As String, ByVal nTimeouts As Long) As Long

Public Declare Function Impact_RTQueryStatus Lib "ImpactDLL.dll" (ByVal hPort As Long, ByVal nPortType As Integer, address As Byte) As Long

Public Declare Function Impact_NETQueryStatus Lib "ImpactDLL.dll" (ByVal nPortType As Integer, ByVal pszPortName1 As String, address As Byte) As Long

Public Declare Function Impact_KickOutDrawer Lib "ImpactDLL.dll" (ByVal hPort As Long, ByVal nPortType As Integer, ByVal nID As Integer, ByVal nOnTimes As Integer, ByVal noffTimes As Integer) As Long

Public Declare Function Impact_StartDoc Lib "ImpactDLL.dll" (ByVal hPort As Long, ByVal nPortType As Integer) As Long

Public Declare Function Impact_EndDoc Lib "ImpactDLL.dll" (ByVal hPort As Long, ByVal nPortType As Integer) As Long



Public Declare Function Impact_S_TextOut Lib "ImpactDLL.dll" (ByVal hPort As Long, ByVal nPortType As Integer, ByVal pszString As String, ByVal nWidthTimes As Long, ByVal nHeightTimes As Long, ByVal nFontType As Long, ByVal nFontStyle As Long) As Long

Public Declare Function Impact_S_DownloadAndPrintBmp Lib "ImpactDLL.dll" (ByVal hPort As Long, ByVal nPortType As Integer, ByVal pszPath As String, ByVal nMode As Long) As Long

Public Declare Function Impact_S_PrintBmpInFlash Lib "ImpactDLL.dll" (ByVal hPort As Long, ByVal nPortType As Integer, ByVal nID As Long, ByVal nMode As Long) As Long


'Data transmission

Public Declare Function Impact_WriteFile Lib "ImpactDLL.dll" (ByVal hPort As Long, ByVal nPortType As Integer, ByVal pszData As String, ByVal nBytesToWrite As Long) As Long

Public Declare Function Impact_ReadFile Lib "ImpactDLL.dll" (ByVal hPort As Long, ByVal nPortType As Integer, ByVal pszData As String, ByVal nBytesToRead As String, ByVal nTimeouts As Long) As Long

Public Declare Function Impact_SetHandle Lib "ImpactDLL.dll" (ByVal hPort As Long, ByVal nPortType As Integer, ByVal hNewHandle As Long) As Long

Public Declare Function Impact_GetVersionInfo Lib "ImpactDLL.dll" (nMajor As Long, nMinor As Long) As Long

'The return value
Public Const Impact_SUCCESS  As Long = 1001
Public Const Impact_FAIL     As Long = 1002
Public Const Impact_ERROR_INVALID_HANDLE        As Long = 1101
Public Const Impact_ERROR_INVALID_PARAMETER     As Long = 1102
Public Const Impact_ERROR_NOT_BITMAP            As Long = 1103
Public Const Impact_ERROR_NOT_MONO_BITMAP       As Long = 1104
Public Const Impact_ERROR_BEYONG_AREA           As Long = 1105
Public Const Impact_ERROR_INVALID_PATH          As Long = 1106

'The number of stop bits options of serial port
Public Const Impact_COM_ONESTOPBIT              As Long = 1
'Public Const Impact_COM_ONE5STOPBITS            As Long = 1.5
Public Const Impact_COM_TWOSTOPBITS             As Long = 2

'Parity options of serial port
Public Const Impact_COM_NOPARITY      As Long = 0
Public Const Impact_COM_ODDPARITY     As Long = 1
Public Const Impact_COM_EVENPARITY    As Long = 2
Public Const Impact_COM_MARKPARITY    As Long = 3
Public Const Impact_COM_SPACEPARITY   As Long = 4

' Flow control options of serial port
Public Const Impact_COM_DTR_DSR      As Long = 0
Public Const Impact_COM_RTS_CTS      As Long = 1
Public Const Impact_COM_XON_XOFF     As Long = 2
Public Const Impact_COM_NO_HANDSHAKE As Long = 3

Public Const Impact_OPEN_SERIAL_PORT As Long = 17
Public Const Impact_OPEN_PARALLEL_PORT As Long = 18
Public Const Impact_OPEN_BYUSB_PORT As Long = 19
Public Const Impact_OPEN_PRINTNAME As Long = 20
Public Const Impact_OPEN_NETPORT   As Long = 21

' Mode options of the way of paper leaving away from printer
Public Const Impact_PAPER_OUT_MODE_CUT      As Long = 0
Public Const Impact_PAPER_OUT_MODE_PEEL     As Long = 1
Public Const Impact_PAPER_OUT_MODE_TEAR     As Long = 2
Public Const Impact_PAPER_OUT_MODE_OTHER    As Long = 3

' Print mode options
Public Const Impact_PRINT_MODE_STANDARD            As Long = 0
Public Const Impact_PRINT_MODE_PAGE                As Long = 1
Public Const Impact_PRINT_MODE_BLACK_MARK_LABEL    As Long = 2
Public Const Impact_PRINT_MODE_WHITE_MARK_LABEL    As Long = 3

' Font type options
Public Const Impact_FONT_TYPE_STANDARD             As Long = 0
Public Const Impact_FONT_TYPE_COMPRESSED           As Long = 1
Public Const Impact_FONT_TYPE_UDC                  As Long = 2
Public Const Impact_FONT_TYPE_CHINESE              As Long = 3

' Font style options
Public Const Impact_FONT_STYLE_NORMAL            As Long = &H0&
Public Const Impact_FONT_STYLE_COMPRESSED        As Long = 1
Public Const Impact_FONT_STYLE_BOLD              As Long = &H8&
Public Const Impact_FONT_STYLE_UNDERLINE         As Long = &H80&

' Specify the area direction of paper or lable
Public Const Impact_AREA_LEFT_TO_RIGHT    As Long = 0
Public Const Impact_AREA_BOTTOM_TO_TOP    As Long = 1
Public Const Impact_AREA_RIGHT_TO_LEFT    As Long = 2
Public Const Impact_AREA_TOP_TO_BOTTOM    As Long = 3

' Cut mode options
Public Const Impact_CUT_MODE_FULL_NoMarker       As Long = 0
Public Const Impact_CUT_MODE_PARTIAL_NoMarker    As Long = 1
Public Const Impact_CUT_MODE_FULL                As Long = &H41& '0     'Ĭȫ
Public Const Impact_CUT_MODE_PARTIAL             As Long = &H42& '1     'Ĭϰ

' Mode options of printing bit image in RAM or Flash
Public Const Impact_BITMAP_PRINT_NORMAL        As Long = 0
Public Const Impact_BITMAP_PRINT_DOUBLE_WIDTH  As Long = 1

' Mode options of bit-image -- for download and print
Public Const Impact_BITMAP_MODE_8SINGLE_DENSITY  As Long = &H0&
Public Const Impact_BITMAP_MODE_8DOUBLE_DENSITY  As Long = &H1&
Public Const Impact_BITMAP_MODE_24SINGLE_DENSITY As Long = &H20&
Public Const Impact_BITMAP_MODE_24DOUBLE_DENSITY As Long = &H21&


' Barcode HRI's position
Public Const Impact_HRI_POSITION_NONE  As Long = &H0&
Public Const Impact_HRI_POSITION_ABOVE  As Long = &H1&
Public Const Impact_HRI_POSITION_BELOW As Long = &H2&
Public Const Impact_HRI_POSITION_BOTH As Long = &H3&


Public Function PrintSamples(ByVal g_hPort As Long, ByVal nPortType As Integer) As Long

    Dim bIsFirst As Boolean
    Dim state As Integer
    Dim bmp As String
    Dim ErrID As Integer
    
    
    bmp = "Kitty.bmp"
    
    bIsFirst = True
    
    If (bIsFirst = True) Then
        state_print = Impact_PreDownloadBmpsToFlash(g_hPort, nPortType, "Kitty.bmp", 1, ErrID) 'Pre-download a group of bit map to Flash by specifying it's ID.
        If state_print <> 1001 Then
            Exit Function
        End If
        bIsFirst = False
    End If
  
   ' Dim m_BmpPath As String
   ' m_BmpPath = "Look.bmp"
    'If hasdowntoFlash80 = False Then
       'a = POS_PreDownloadBmpsToFlash(m_BmpPath, 1)
    '   a = Impact_PreDownloadBmpsToFlash(g_hPort, nPortType, "Look.bmp", 1, ErrID)
     '  hasdowntoFlash80 = True
    'End If

     
    
    state = Impact_SetRightSpacing(g_hPort, nPortType, 0)

    state = Impact_SetLineSpacing(g_hPort, nPortType, 24)

    state = Impact_S_TextOut(g_hPort, nPortType, "Impact Printer", 1, 1, Impact_FONT_TYPE_STANDARD, Impact_FONT_STYLE_UNDERLINE)
        
    state = Impact_FeedLine(g_hPort, nPortType)
    
    state = Impact_S_TextOut(g_hPort, nPortType, "ʽӡ", 2, 1, Impact_FONT_TYPE_CHINESE, Impact_FONT_STYLE_BOLD)
    
    state = Impact_FeedLine(g_hPort, nPortType)
    
    state = Impact_S_TextOut(g_hPort, nPortType, " ʽ  ӡ ", 1, 2, Impact_FONT_TYPE_CHINESE, Impact_FONT_STYLE_NORMAL)
    
    state = Impact_FeedLine(g_hPort, nPortType)
    
    state = Impact_FeedLine(g_hPort, nPortType)

    state = Impact_SetLineSpacing(g_hPort, nPortType, 24)

    ' ַͬҼ
    
    state = Impact_SetRightSpacing(g_hPort, nPortType, 0)
    
    state = Impact_S_TextOut(g_hPort, nPortType, "BTP-M280", 1, 1, Impact_FONT_TYPE_STANDARD, Impact_FONT_STYLE_BOLD)
     
    state = Impact_S_TextOut(g_hPort, nPortType, "Impact Printer", 1, 1, Impact_FONT_TYPE_STANDARD, Impact_FONT_STYLE_BOLD)
    
    state = Impact_FeedLine(g_hPort, nPortType)
    

    state = Impact_SetRightSpacing(g_hPort, nPortType, 2)
    
    state = Impact_S_TextOut(g_hPort, nPortType, "BTP-M280", 1, 1, Impact_FONT_TYPE_STANDARD, Impact_FONT_STYLE_UNDERLINE)
    
    state = Impact_S_TextOut(g_hPort, nPortType, "Impact Printer", 1, 1, Impact_FONT_TYPE_STANDARD, Impact_FONT_STYLE_UNDERLINE)
        
    state = Impact_FeedLine(g_hPort, nPortType)
    
    
    state = Impact_SetRightSpacing(g_hPort, nPortType, 4)
    
    state = Impact_S_TextOut(g_hPort, nPortType, "BTP-M280", 1, 1, Impact_FONT_TYPE_STANDARD, Impact_FONT_STYLE_NORMAL)
    
    state = Impact_S_TextOut(g_hPort, nPortType, "Impact Printer", 1, 1, Impact_FONT_TYPE_STANDARD, Impact_FONT_STYLE_NORMAL)
        
    state = Impact_FeedLine(g_hPort, nPortType)

    
    state = Impact_FeedLine(g_hPort, nPortType)


    ' ַͬ

    state = Impact_SetRightSpacing(g_hPort, nPortType, 2)
    
    state = Impact_S_TextOut(g_hPort, nPortType, "ӡ", 1, 1, Impact_FONT_TYPE_CHINESE, Impact_FONT_STYLE_NORMAL)
        
    state = Impact_FeedLine(g_hPort, nPortType)
    
    state = Impact_FeedLine(g_hPort, nPortType)
    
    state = Impact_FeedLine(g_hPort, nPortType)

    

    ' ӡص Flash еλͼ

    state = Impact_FeedLine(g_hPort, nPortType)
    
    state = Impact_S_TextOut(g_hPort, nPortType, "-------------> Logo 1", 1, 1, Impact_FONT_TYPE_STANDARD, Impact_FONT_STYLE_NORMAL)
    
    state = Impact_FeedLine(g_hPort, nPortType)
    
    state = Impact_S_PrintBmpInFlash(g_hPort, nPortType, 1, Impact_BITMAP_PRINT_NORMAL)
    
    state = Impact_FeedLine(g_hPort, nPortType)
    
    state = Impact_FeedLine(g_hPort, nPortType)
      
    state = Impact_FeedLine(g_hPort, nPortType)

    
    state6 = Impact_CutPaper(g_hPort, nPortType, Impact_CUT_MODE_FULL, 0)
    
    
    
End Function




