unit ImpactdllFuncs;

interface

uses
  Classes;

type
  PInt = ^Integer;

function Impact_Open(pszPortName: pchar; nComBaudrate: integer; nComDataBits: integer; nComStopBits: integer; nComParity: Integer; nComFlowControl: Integer): Integer; stdcall; external 'ImpactDLL.dll';

function Impact_Close(hPort:Thandle;nPortType:Integer): Integer; stdcall; external 'ImpactDLL.dll';

function Impact_Reset(hPort:Thandle;nPortType:Integer): Integer; stdcall; external 'ImpactDLL.dll';

function Impact_SetCharSetAndCodePage(hPort:Thandle;nPortType:Integer;nCharSet: Integer; nCodePage: Integer): integer; stdcall; external 'ImpactDLL.dll';

function Impact_FeedLine(hPort:Thandle;nPortType:Integer): Integer; stdcall; external 'ImpactDLL.dll';

function Impact_SetLineSpacing(hPort:Thandle;nPortType:Integer;nDistance:integer):integer;stdcall;external 'ImpactDLL.dll';

function Impact_SetRightSpacing(hPort:Thandle;nPortType:Integer;nMode:integer):integer;stdcall;external 'ImpactDLL.dll';

function Impact_CutPaper(hPort:Thandle;nPortType:Integer;nMode:integer;nDistance:integer):integer;stdcall;external 'ImpactDLL.dll';

function Impact_QueryStatus(hPort:Thandle;nPortType:Integer;pszStatus: PChar; nTimeouts: Integer): Integer; stdcall; external 'ImpactDLL.dll';

function Impact_RTQueryStatus(hPort:Thandle;nPortType:Integer;pszStatus: PChar):integer; stdcall;external 'ImpactDLL.dll';

function Impact_KickOutDrawer(hPort:Thandle;nPortType:Integer;nID: Integer; nOnTimes: Integer; nOffTimes: Integer): Integer; stdcall; external 'ImpactDLL.dll';

function Impact_PreDownloadBmpsToFlash(hPort:Thandle;nPortType:Integer;pszPath:Pointer; nCount:integer;var ErrBmpID:Pinteger):integer;stdcall;external 'ImpactDLL.dll';

function Impact_S_TextOut(hPort:Thandle;nPortType:Integer;pszString:pchar;nWidthTimes:integer;nHeightTimes:integer;nFontType:integer;nFontStyle:integer):integer;stdcall;external 'ImpactDLL.dll';

function Impact_S_DownloadAndPrintBmp(hPort:Thandle;nPortType:Integer;pszPath: PChar; nMode: Integer): Integer; stdcall; external 'ImpactDLL.dll';

function Impact_S_PrintBmpInFlash(hPort:Thandle;nPortType:Integer;nID:integer;nMode:integer):integer;stdcall;external 'ImpactDLL.dll';

function Impact_WriteFile(hPort:Thandle;nPortType:Integer; pszData: PChar; nBytesToWrite: Integer): Integer; stdcall; external 'ImpactDLL.dll';

function Impact_ReadFile(hPort:Thandle;nPortType:Integer; pszData: PChar; nBytesToRead: Integer; nTimeouts: Integer): Integer; stdcall; external 'ImpactDLL.dll';

function Impact_SetHandle(hPort:Thandle;nPortType:Integer;hNewHandle: Thandle): Integer; stdcall; external 'ImpactDLL.dll';

function Impact_GetVersionInfo(pnMajor: PInt; pnMinor: PInt): Integer; stdcall; external 'ImpactDLL.dll';

function Impact_StartDoc(hPort:Thandle;nPortType:Integer):Boolean; stdcall; external 'ImpactDLL.dll';

function Impact_EndDoc(hPort:Thandle;nPortType:Integer):Boolean; stdcall; external 'ImpactDLL.dll';

function Impact_NETQueryStatus(nPortType:Integer; ipAddress :pchar; pszStatus:pchar ):Integer; stdcall; external 'ImpactDLL.dll';

procedure Impact_BeginSaveFile(hPort:Thandle;lpFileName :pchar;bToPrinter:boolean); stdcall; external 'ImpactDLL.dll';

procedure Impact_EndSaveFile(hPort:Thandle);stdcall; external 'ImpactDLL.dll';

//ֵ
Const Impact_SUCCESS                    = 1001;   //ִгɹ
Const Impact_FAIL                       = 1002;   //ִʧ
Const Impact_ERROR_INVALID_HANDLE       = 1101;   //˿ڻļľЧ
Const Impact_ERROR_INVALID_PARAMETER    = 1102;   //Ч
Const Impact_ERROR_NOT_BITMAP           = 1103;   //λͼʽļ
Const Impact_ERROR_NOT_MONO_BITMAP      = 1104;   //λͼǵɫ
Const Impact_ERROR_BEYONG_AREA          = 1105;   //λͼӡԴĴС
Const Impact_ERROR_INVALID_PATH         = 1106;   //ûҵָļ·

//Уλ
Const Impact_COM_NOPARITY               = 0;      //У
Const Impact_COM_ODDPARITY              = 1;      //У
Const Impact_COM_EVENPARITY             = 2;      //żУ
Const Impact_COM_MARKPARITY             = 3;      //У
Const Impact_COM_SPACEPARITY            = 4;      //ոУ

//Ʋ
Const Impact_COM_DTR_DSR                = 0;      //ΪDTR/DST
Const Impact_COM_RTS_CTS                = 1;      //ΪRTS/CTS
Const Impact_COM_XON_XOFF               = 2;      //ΪXON/OFF
Const Impact_COM_NO_HANDSHAKE           = 3;      //

Const Impact_OPEN_SERIAL_PORT			      = $11;    //򿪴ͨѶ˿
Const Impact_OPEN_PARALLEL_PORT		      = $12;    //򿪲ͨѶ˿
Const Impact_OPEN_BYUSB_PORT			      = $13;    //USBͨѶ˿
Const Impact_OPEN_PRINTNAME			        = $14;    //򿪴ӡ
Const Impact_OPEN_NETPORT				        = $15;    //̫ӡ

//Ͷ
Const Impact_FONT_TYPE_STANDARD         = 0;      //׼ ASCII
Const Impact_FONT_TYPE_COMPRESSED       = 1;      //ѹ ASCII
Const Impact_FONT_TYPE_CHINESE          = 3;      //׼ 塱

//嶨
Const Impact_FONT_STYLE_NORMAL          = $0;     //
Const Impact_FONT_STYLE_COMPRESSED      = $1;     //ѹ
Const Impact_FONT_STYLE_BOLD            = $8;     //Ӵ
Const Impact_FONT_STYLE_UNDERLINE       = $80;    //»

//еģʽ
Const Impact_CUT_MODE_FULL_NoMarker     = 0;      //ĬȫУұ
Const Impact_CUT_MODE_PARTIAL_NoMarker  = 1;      //ĬϰУұ
Const Impact_CUT_MODE_FULL              = $41;    //Ĭȫ
Const Impact_CUT_MODE_PARTIAL           = $42;    //Ĭϰ

//λͼģʽ
Const Impact_BITMAP_PRINT_NORMAL        = 0;      //
Const Impact_BITMAP_PRINT_DOUBLE_WIDTH  = 1;      //

implementation

end.
